//---------------------------------------------------------------------------
//
//   MQ3DLib.h      Copyright(C) 1999-2000, O.Mizno
//
//    @ƕ֗Ȋ֐WB
//
//---------------------------------------------------------------------------

#ifndef MQ3DLIB_H
#define MQ3DLIB_H

#include <math.h>

//~
#ifndef PI
	#define PI 3.1415926536f
#endif

//ʓx(0360)烉WA(02)֕ϊ
#ifndef RAD
	#define RAD(x) ((x)/180.0f*PI)
#endif

//WA(02)ʓx(0360)֕ϊ
#ifndef DEG
	#define DEG(x) ((x)/PI*180.0f)
#endif

//xNg̃TCY
inline float GetSize(MQPoint &p)
	{ return (float)sqrt(p.x*p.x + p.y*p.y + p.z*p.z); }

//xNg̐K
inline MQPoint Normalize(MQPoint &p){
	float s = GetSize(p);
	return (s>0) ? p/s : MQPoint(0,0,0);
}

//ς̒l𓾂
inline float GetInnerProduct(MQPoint &pa, MQPoint &pb)
	{ return pa.x * pb.x + pa.y * pb.y + pa.z * pb.z; }

//OσxNg𓾂
inline MQPoint GetExteriorProduct(MQPoint &v1, MQPoint &v2){
	return MQPoint(
		v1.y * v2.z - v1.z * v2.y,
		v1.z * v2.x - v1.x * v2.z,
		v1.x * v2.y - v1.y * v2.x);
}
inline MQPoint GetCrossProduct(MQPoint &v1, MQPoint &v2)
	{ return GetExteriorProduct(v1, v2); }

//3_Ȃʂ̖@𓾂
MQPoint GetNormal(MQPoint p0, MQPoint p1, MQPoint p2);

//2xNǧpxWAPʂ0΂܂ł̒lœ
float GetCrossingAngle(MQPoint &v1, MQPoint &v2);

// Ό̖ʂ݂邩ǂ𒲂ׂ
// ݂Ă΂̖ʂ̃CfbNXAȂ-1Ԃ
int SearchInvertedFace(MQObject obj, int faceindex, int start=-1, int end=-1);


class MQObjEdgePair
{
public:
	int face;
	int line;

	inline MQObjEdgePair() { face = line = -1; }
	inline MQObjEdgePair(int f, int l) { face = f; line = l; }
	inline MQObjEdgePair& operator = (const MQObjEdgePair& r)
		{ face=r.face; line=r.line; return *this; }
};

typedef MQObjEdgePair MQObjEdgePairFace[4];

// IuWFNg̃GbWǗNX
class MQObjEdge
{
protected:
	int m_face;
	MQObject m_obj;
	MQObjEdgePairFace *m_pair;
public:
	MQObjEdge(MQObject obj);
	virtual ~MQObjEdge();

	bool getPair(int face_index, int line_index, int& pair_face, int& pair_line);
};


#endif //MQ3DLIB_H