//---------------------------------------------------------------------------
//
//   subdivide
//
//          Copyright(C) 1999-2000, O.Mizno
//
//    @IuWFNg̍ĕsIuWFNgvOC̃TvB
//    @쐬DLL"Plugins\Object"tH_ɓKvB
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "MQPlugin.h"
#include "MQ3DLib.h"

BOOL CatmullClark(MQDocument doc);
BOOL Butterfly(MQDocument doc);
BOOL Sqrt3(MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0xA90FF4C5;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "Subdivide           Copyright(C) 2000, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// IuWFNgό`pvOCł
	return MQPLUGIN_TYPE_OBJECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "Catmull-Clark subdivision";
	case 1: return "Butterfly subdivision";
	case 2: return "SQRT3 subdivision";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQModifyObject
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifyObject(int index, MQDocument doc)
{
	switch(index){
	case 0: return CatmullClark(doc);
	case 1: return Butterfly(doc);
	case 2: return Sqrt3(doc);
	}
	return FALSE;
}

//---------------------------------------------------------------------------
//  class SSVertex, SSLineVertex, EdgeHash, intvector
//    _ӂɊւ𑀍삷NX
//---------------------------------------------------------------------------
class SSVertex {
public:
	MQPoint p;
	int index;

	SSVertex() {
		p = MQPoint(0,0,0);
		index = -2;
	}
};

typedef	SSVertex SSLineVertex[4];

class EdgeHash
{
public:
	int face, line;
	int vertex;
	EdgeHash *next;

	EdgeHash(int f, int l, int v) {
		face = f;
		line = l;
		vertex = v;
		next = NULL;
	}
	virtual ~EdgeHash() {
		if(next != NULL)
			delete next;
	}
	void Add(EdgeHash *hash) {
		if(next != NULL)
			next->Add(hash);
		else
			next = hash;
	}
	EdgeHash *Search(int v)
	{
		if(v == vertex)
			return this;
		if(next != NULL)
			return next->Search(v);
		return NULL;
	}
};

class intvector
{
protected:
	int *array;
	int array_count;
	int array_size;

	inline bool is_filled() const { return array_count == array_size; }
	inline void extend() {
		if(is_filled())
			reserve(array_size * 2 + 16);
	}

public:
	intvector() {
		array = NULL;
		array_count = array_size = 0;
	}
	virtual ~intvector() {
		clear();
	}

	void reserve(int newsize) {
		array = (int *)realloc(array, sizeof(int) * newsize);
		array_size = newsize;
		if(array_count > newsize)
			array_count = newsize;
	}
	inline void resize(int newsize) {
		reserve(newsize);
		array_count = newsize;
	}
	inline void clear() {
		free(array);
		array_count = array_size = 0;
	}

	inline int size() const { return array_count; }

	inline void push_back(int value) {
		extend();
		array[array_count++] = value;		
	}

	inline int pop_back(int value) {
		return array[--array_count];
	}

	void push_front(int value) {
		extend();
		for(int i=array_count; i>0; i--)
			array[i] = array[i-1];
		array[0] = value;
	}

	inline int& operator[] (int index) const {
		return array[index];
	}
	inline void operator<< (int value) {
		push_back(value);
	}
};

//---------------------------------------------------------------------------
//  TriangulateObject()
//    IuWFNĝׂĂ̖ʂOp`
//---------------------------------------------------------------------------
void TriangulateObject(MQObject obj)
{
	MQCoordinate orguv[4], newuv[4];
	int vert_index[4];
	int face_count = obj->GetFaceCount();

	// ׂĂ̖ʂOp`
	for(int face=0; face<face_count; face++)
	{
		int count = obj->GetFacePointCount(face);
		if(count != 4)
			continue;

		int mat_index = obj->GetFaceMaterial(face);
		obj->GetFacePointArray(face, vert_index);
		obj->GetFaceCoordinateArray(face, orguv);

		int index[3], newface;

		index[0] = vert_index[0];
		index[1] = vert_index[1];
		index[2] = vert_index[2];
		newuv[0] = orguv[0];
		newuv[1] = orguv[1];
		newuv[2] = orguv[2];
		newface = obj->AddFace(3, index);
		obj->SetFaceMaterial(newface, mat_index);
		obj->SetFaceCoordinateArray(newface, newuv);
		
		index[0] = vert_index[0];
		index[1] = vert_index[2];
		index[2] = vert_index[3];
		newuv[0] = orguv[0];
		newuv[1] = orguv[2];
		newuv[2] = orguv[3];
		newface = obj->AddFace(3, index);
		obj->SetFaceMaterial(newface, mat_index);
		obj->SetFaceCoordinateArray(newface, newuv);

		obj->DeleteFace(face);
	}

	// IuWFNg̃RpNg
	obj->Compact();
}


//---------------------------------------------------------------------------
//  CatmullClark()
//
//    Catmull-Clark̃ASYɊÂĕ
//    SɕĂȂꍇ̏sĂ
//    ASYɂĂ͈ȉURLQ
//      http://muldoon.cipic.ucdavis.edu/CAGDNotes
//      http://www.gamasutra.com/features/20000411/sharp_04.htm
//---------------------------------------------------------------------------
BOOL CatmullClark(MQDocument doc)
{
	int obj_index;
	int face_count, vert_count;
	int face, vert, vert_index[4];
	SSVertex *q, *v;
	SSLineVertex *r;
	EdgeHash **edge;
	MQCoordinate orguv[4], newuv[4];

	// JgIuWFNg̎擾
	obj_index = doc->GetCurrentObjectIndex();
	if(obj_index < 0)
		return FALSE;
	MQObject obj = doc->GetObject(obj_index);
	if(obj == NULL)
		return FALSE;

	face_count = obj->GetFaceCount();
	vert_count = obj->GetVertexCount();
	
	// Vzu_̃obt@
	q = new SSVertex[face_count];
	r = new SSLineVertex[face_count];
	v = new SSVertex[vert_count];

	// GbWp̃nbV
	edge = new EdgeHash *[vert_count];
	for(vert=0; vert<vert_count; vert++)
		edge[vert] = NULL;
	for(face=0; face<face_count; face++)
	{
		int count = obj->GetFacePointCount(face);
		if(count < 3) continue;

		obj->GetFacePointArray(face, vert_index);
		for(vert=0; vert<count; vert++)
		{
			int v1 = vert_index[vert];
			int v2 = vert_index[(vert+1)%count];
			if(edge[v1] != NULL)
				edge[v1]->Add(new EdgeHash(face, vert, v2));
			else 
				edge[v1] = new EdgeHash(face, vert, v2);
			if(edge[v2] != NULL)
				edge[v2]->Add(new EdgeHash(face, vert, v1));
			else 
				edge[v2] = new EdgeHash(face, vert, v1);
		}
	}

	// ʂ̒S_(Q)𓾂
	for(face=0; face<face_count; face++)
	{
		int count = obj->GetFacePointCount(face);
		if(count < 3) continue;

		obj->GetFacePointArray(face, vert_index);
		for(vert=0; vert<count; vert++)
			q[face].p += obj->GetVertex(vert_index[vert]);
		q[face].p /= (float)count;
		q[face].index = -1;
	}

	// ӂ̓_(R)𓾂
	for(face=0; face<face_count; face++)
	{
		int count = obj->GetFacePointCount(face);
		if(count < 3)
			continue;

		obj->GetFacePointArray(face, vert_index);
		for(vert=0; vert<count; vert++)
		{
			int v1 = vert_index[vert];
			int v2 = vert_index[(vert+1)%count];

			EdgeHash *hash = edge[v2];
			for(; hash!=NULL; hash=hash->next) {
				if(hash->vertex == v1 && hash->face != face) {
					r[face][vert].p = (
						obj->GetVertex(v1) + obj->GetVertex(v2) + q[face].p + q[hash->face].p) / 4;
					break;
				}					
			}
			// GbWĂȂ̏
			if(hash == NULL) {
				v[v1].p = obj->GetVertex(v1);
				v[v1].index = -1;
				v[v2].p = obj->GetVertex(v2);
				v[v2].index = -1;
				r[face][vert].p = (v[v1].p + v[v2].p) / 2;
			}
			r[face][vert].index = -1;
		}
	}

	// IWi̓_ɏ]V_(V)𓾂
	for(vert=0; vert<vert_count; vert++)
	{
		if(v[vert].index == -1)
			continue;

		EdgeHash *hash = edge[vert];
		int count = 0;
		for(; hash!=NULL; hash=hash->next){
			EdgeHash *h2 = edge[vert];
			for(; h2!=hash; h2=h2->next){
				if(hash->face == h2->face)
					break;
			}
			if(h2 == hash) {
				v[vert].p += q[hash->face].p;
				count++;
			}
			for(h2=edge[vert]; h2!=hash; h2=h2->next){
				if(hash->vertex == h2->vertex)
					break;
			}
			if(h2 == hash)
#if 0
				v[vert].p += r[hash->face][hash->line].p;
#else
				v[vert].p += obj->GetVertex(hash->vertex);
#endif
		}
		if(count > 0) {
			v[vert].p /= (float)count;
			v[vert].p += (float)(count - 2) * obj->GetVertex(vert);
			v[vert].p /= (float)count;
			v[vert].index = -1;
		}
	}

	// V_o^
	for(vert=0; vert<vert_count; vert++) {
		if(v[vert].index == -1)
			v[vert].index = obj->AddVertex(v[vert].p);
	}
	for(face=0; face<face_count; face++)
	{
		int count = obj->GetFacePointCount(face);
		if(count < 3) continue;

		obj->GetFacePointArray(face, vert_index);
		q[face].index = obj->AddVertex(q[face].p);

		for(vert=0; vert<count; vert++)
		{
			int v1 = vert_index[vert];
			int v2 = vert_index[(vert+1)%count];

			EdgeHash *hash = edge[v2];
			for(; hash!=NULL; hash=hash->next) {
				if(hash->vertex == v1 && r[hash->face][hash->line].index >= 0) {
					r[face][vert].index = r[hash->face][hash->line].index;
					break;
				}	
			}
			if(hash == NULL)
				r[face][vert].index = obj->AddVertex(r[face][vert].p);
		}
	}

	// Vĕꂽʂo^
	for(face=0; face<face_count; face++)
	{
		int count = obj->GetFacePointCount(face);
		if(count < 3) continue;

		int mat_index = obj->GetFaceMaterial(face);
		obj->GetFacePointArray(face, vert_index);
		obj->GetFaceCoordinateArray(face, orguv);

		int index[4];
		for(vert=0; vert<count; vert++)
		{
			index[0] = v[vert_index[vert]].index;
			index[1] = r[face][vert].index;
			index[2] = q[face].index;
			index[3] = r[face][(vert+count-1)%count].index;
			int newface = obj->AddFace(4, index);
			if(newface >= 0)
			{
				obj->SetFaceMaterial(newface, mat_index);
				newuv[0] = orguv[vert];
				newuv[1] = (orguv[vert] + orguv[(vert+1)%count]) / 2;
				newuv[2] = (orguv[0] + orguv[1] + orguv[2] + orguv[3]) / 4;
				newuv[3] = (orguv[vert] + orguv[(vert+count-1)%count]) / 2;
				obj->SetFaceCoordinateArray(newface, newuv);
			}
		}
	}

	// IWi̖ʂ폜
	for(face=0; face<face_count; face++) {
		if(obj->GetFacePointCount(face) >= 3)
			obj->DeleteFace(face);
	}

	// IuWFNg̃RpNg
	obj->Compact();

	// svɂȂobt@	
	for(vert=0; vert<vert_count; vert++) {
		if(edge[vert] != NULL)
			delete edge[vert];
	}
	delete[] edge;
	delete[] v;
	delete[] r;
	delete[] q;

	return TRUE;
}

//---------------------------------------------------------------------------
//  Butterfly()
//
//    ButterflyXL[ɊÂĕ
//    ASYɂĂ͈ȉURLQ
//      http://www.gamasutra.com/features/20000411/sharp_03.htm
//---------------------------------------------------------------------------
BOOL Butterfly(MQDocument doc)
{
	int obj_index;
	int face_count, vert_count;
	int face, line, vert_index[4];
	MQCoordinate orguv[4], newuv[4];

	// JgIuWFNg̎擾
	obj_index = doc->GetCurrentObjectIndex();
	if(obj_index < 0)
		return FALSE;
	MQObject obj = doc->GetObject(obj_index);
	if(obj == NULL)
		return FALSE;

	// ׂĂ̖ʂOp`
	TriangulateObject(obj);

	face_count = obj->GetFaceCount();
	vert_count = obj->GetVertexCount();

	// GbW̍쐬
	SSLineVertex *r = new SSLineVertex[face_count];
	MQObjEdge *edge = new MQObjEdge(obj);

	// ӂƂ̒S_𓾂
	for(face=0; face<face_count; face++)
	{
		if(obj->GetFacePointCount(face) != 3)
			continue;

		obj->GetFacePointArray(face, vert_index);

		for(line=0; line<3; line++)
		{
			intvector e1, e2;
			int v1, v2, pv[4];
			bool loop = false;
			int pf, pl;
			MQPoint p = MQPoint(0,0,0);

			v1 = vert_index[line];
			e1 << vert_index[(line+1)%3];
			for(pf=face,pl=line+2; ; )
			{
				if( !edge->getPair(pf, (pl+1)%3, pf, pl) )
					break;

				if(pf == face) {
					loop = true;
					break;
				}

				obj->GetFacePointArray(pf, pv);
				e1 << pv[(pl+2)%3];
			}

			v2 = vert_index[(line+1)%3];
			e2 << vert_index[line];
			for(pf=face,pl=line+1; ; )
			{
				if( !edge->getPair(pf, (pl+2)%3, pf, pl) )
					break;

				if(pf == face) {
					loop = true;
					break;
				}

				obj->GetFacePointArray(pf, pv);
				e2 << pv[(pl+2)%3];
			}

			if(e1.size() == 6 && e2.size() == 6)
			{
				p += obj->GetVertex(v1) * 0.5;
				p += obj->GetVertex(v2) * 0.5;
				p += obj->GetVertex(e1[1]) * 0.125;
				p += obj->GetVertex(e2[5]) * 0.125;
				p -= obj->GetVertex(e1[2]) * 0.0625;
				p -= obj->GetVertex(e1[4]) * 0.0625;
				p -= obj->GetVertex(e2[2]) * 0.0625;
				p -= obj->GetVertex(e2[4]) * 0.0625;
			}
			else
			{
				p += obj->GetVertex(v1) * 0.75;
				switch(e1.size()) {
				case 3:
					p += (obj->GetVertex(e1[0])*5 - obj->GetVertex(e1[1]) - obj->GetVertex(e1[2])) / 12.f;
					break;
				case 4:
					p += (obj->GetVertex(e1[0])*3 - obj->GetVertex(e1[2])) * 0.125f;
					break;
				default:
					double in = 1.0 / (double)e1.size();
					for(int i=0; i<e1.size(); i++)
						p += obj->GetVertex(e1[i]) *
							(float)(0.25 + cos(2.0*PI*(double)i*in) + 0.5*cos(4.0*PI*(double)i*in)) * (float)in;
				}

				p += obj->GetVertex(v2) * 0.75;
				switch(e2.size()) {
				case 3:
					p += (obj->GetVertex(e2[0])*5 - obj->GetVertex(e2[1]) - obj->GetVertex(e2[2])) / 12.f;
					break;
				case 4:
					p += (obj->GetVertex(e2[0])*3 - obj->GetVertex(e2[2])) * 0.125f;
					break;
				default:
					double in = 1.0 / (double)e2.size();
					for(int i=0; i<e2.size(); i++)
						p += obj->GetVertex(e2[i]) *
							(float)(0.25 + cos(2.0*PI*(double)i*in) + 0.5*cos(4.0*PI*(double)i*in)) * (float)in;
				}

				p *= 0.5;
			}

			int vi = obj->AddVertex(p);
			r[face][line].index = vi;
			r[face][line].p = p;

			if( edge->getPair(face, line, pf, pl) ) {
				r[pf][pl].index = vi;
				r[pf][pl].p = p;
			}
		}
	}

	// ĕꂽʂo^
	for(face=0; face<face_count; face++)
	{
		if(obj->GetFacePointCount(face) != 3)
			continue;

		int newface, index[3];
		int mat_index = obj->GetFaceMaterial(face);
		obj->GetFacePointArray(face, vert_index);
		obj->GetFaceCoordinateArray(face, orguv);

		for(line=0; line<3; line++)
		{
			index[0] = vert_index[line];
			index[1] = r[face][line].index;
			index[2] = r[face][(line+2)%3].index;
			newface = obj->AddFace(3, index);
			obj->SetFaceMaterial(newface, mat_index);
			newuv[0] = orguv[line];
			newuv[1] = (orguv[line] + orguv[(line+1)%3]) * 0.5;
			newuv[2] = (orguv[line] + orguv[(line+2)%3]) * 0.5;
			obj->SetFaceCoordinateArray(newface, newuv);
		}

		index[0] = r[face][0].index;
		index[1] = r[face][1].index;
		index[2] = r[face][2].index;
		newface = obj->AddFace(3, index);
		obj->SetFaceMaterial(newface, mat_index);
		newuv[0] = (orguv[0] + orguv[1]) * 0.5;
		newuv[1] = (orguv[1] + orguv[2]) * 0.5;
		newuv[2] = (orguv[2] + orguv[0]) * 0.5;
		obj->SetFaceCoordinateArray(newface, newuv);

		obj->DeleteFace(face);
	}

	delete edge;
	delete[] r;

	// IuWFNg̃RpNg
	obj->Compact();

	return TRUE;
}

//---------------------------------------------------------------------------
//  Sqrt3()
//
//    Sqrt(3)XL[ɊÂĕiȉ̘_QƁj
//       Leif Kobbelt, "Sqrt(3)-Subdivision", SIGGRAPH2000 proceedings
//    _ɏꂽ@̂Œ̕pAI
//    EGbWȂǂ͍̏sĂȂ
//    ܂ꂽ@ʂɐĂ邩ǂ͕s
//---------------------------------------------------------------------------
BOOL Sqrt3(MQDocument doc)
{
	int obj_index;
	int face_count, vert_count;
	int face, line, vert, vert_index[4];
	MQCoordinate orguv[4], pairuv[4], newuv[4];

	// JgIuWFNg̎擾
	obj_index = doc->GetCurrentObjectIndex();
	if(obj_index < 0)
		return FALSE;
	MQObject obj = doc->GetObject(obj_index);
	if(obj == NULL)
		return FALSE;

	// ׂĂ̖ʂOp`
	TriangulateObject(obj);

	face_count = obj->GetFaceCount();
	vert_count = obj->GetVertexCount();

	class SPVert {
	public:
		MQPoint v;
		int n;

		SPVert() {
			v = MQPoint(0,0,0);
			n = 0;
		}

		void add(const MQPoint& p) {
			v += p;
			n++;
		}
		MQPoint getAvePoint() {
			if(n == 0)
				return MQPoint(0,0,0);
			return v / (float)n;
		}
	};

	// GbW̍쐬
	SSVertex *nv = new SSVertex[face_count];
	MQObjEdge *edge = new MQObjEdge(obj);
	SPVert *sp = new SPVert[vert_count];

	// ʂƂɒS_}
	for(face=0; face<face_count; face++)
	{
		if(obj->GetFacePointCount(face) != 3)
			continue;

		obj->GetFacePointArray(face, vert_index);

		nv[face].p = MQPoint(0,0,0);

		for(line=0; line<3; line++)
		{
			nv[face].p += obj->GetVertex(vert_index[line]);

			int pf, pl;
			if( edge->getPair(face, line, pf, pl) ) {
				if(pf < face)
					continue;
			}
			sp[vert_index[(line+1)%3]].add(obj->GetVertex(vert_index[line]));
			sp[vert_index[ line     ]].add(obj->GetVertex(vert_index[(line+1)%3]));
		}

		nv[face].index = obj->AddVertex(nv[face].p / 3.0f);
	}

	// IWi_̃X[WO
	for(vert=0; vert<vert_count; vert++)
	{
		if(sp[vert].n > 0) {
			float alpha = (float)((4.0 - 2.0 * cos(2.0 * PI / (double)sp[vert].n)) / 9.0);
			obj->SetVertex(vert, 
				obj->GetVertex(vert) * (1.0f-alpha) + alpha * sp[vert].getAvePoint());
		}
	}

	// ʂ̍č\
	for(face=0; face<face_count; face++)
	{
		if(obj->GetFacePointCount(face) != 3)
			continue;

		obj->GetFacePointArray(face, vert_index);
		obj->GetFaceCoordinateArray(face, orguv);
		int mat_index = obj->GetFaceMaterial(face);

		for(line=0; line<3; line++)
		{
			int pf, pl, index[3], nf;

			if( edge->getPair(face, line, pf, pl) )
			{
				if(face < pf)
					continue;

				obj->GetFaceCoordinateArray(pf, pairuv);

				index[0] = vert_index[line];
				index[1] = nv[pf].index;
				index[2] = nv[face].index;
				nf = obj->AddFace(3, index);
				obj->SetFaceMaterial(nf, mat_index);
				newuv[0] = orguv[line];
				newuv[1] = (pairuv[0] + pairuv[1] + pairuv[2]) / 3.0f;
				newuv[2] = (orguv[0] + orguv[1] + orguv[2]) / 3.0f;
				obj->SetFaceCoordinateArray(nf, newuv);

				index[0] = vert_index[(line+1)%3];
				index[1] = nv[face].index;
				index[2] = nv[pf].index;
				nf = obj->AddFace(3, index);
				obj->SetFaceMaterial(nf, mat_index);
				newuv[0] = orguv[(line+1)%3];
				newuv[1] = (orguv[0] + orguv[1] + orguv[2]) / 3.0f;
				newuv[2] = (pairuv[0] + pairuv[1] + pairuv[2]) / 3.0f;
				obj->SetFaceCoordinateArray(nf, newuv);
			}
			else
			{
				index[0] = nv[face].index;
				index[1] = vert_index[line];
				index[2] = vert_index[(line+1)%3];
				nf = obj->AddFace(3, index);
				obj->SetFaceMaterial(nf, mat_index);
				newuv[0] = (orguv[0] + orguv[1] + orguv[2]) / 3.0f;
				newuv[1] = orguv[line];
				newuv[2] = orguv[(line+1)%3];
				obj->SetFaceCoordinateArray(nf, newuv);
			}
		}

	}

	// IWiʂ폜
	for(face=0; face<face_count; face++)
	{
		if(obj->GetFacePointCount(face) == 3)
			obj->DeleteFace(face);
	}

	delete[] sp;
	delete edge;
	delete[] nv;

	// IuWFNg̃RpNg
	obj->Compact();

	return TRUE;
}
